/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package parseme;


import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;

/**
 *
 * @author Behrang QasemiZadeh <me at atmykitchen.info>
 */
public class ParsemeTokenise {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args)  {
        try {
            if (args.length != 2) {
                System.out.println("Please provide path to input file and the output");
                System.exit(0);
            } else if (args[0].equalsIgnoreCase(args[1])) {
                System.out.println("Input and output path cannot be the same");
                System.exit(0);
            }
            
            
            BufferedReader br = null;
            try {
                br = new BufferedReader( new InputStreamReader(
                      new FileInputStream(args[0]), "UTF8"));
            } catch (FileNotFoundException ex) {
                System.out.println("The specified input file cannot be found... please double check!");
                System.exit(0);
            }
            
            PrintWriter pw = null;
            try {
                pw = new PrintWriter( args[1], "UTF-8");
            } catch (IOException ex) {
                System.out.println("The specified path for the output file cannot be accessed... please double check!");
                System.exit(0);
            }
            // delimiters are loaded in different lists to be able to mark nsb
            String blankDel = null;
            String punctDel = null;
            try {
                blankDel = loadSeparators("resource/blanc_chars.txt");
                
                punctDel = loadSeparators("resource/punct_chars.txt");
            } catch (IOException ex) {
                System.out.println("Error while loading resouces ... make sure resource/blanc_chars.txt and resource/punct_chars.txt exist!");
            }
            System.out.println("delimiter characters are loaded from the *resource* folder");
            System.out.println("Please note the code igoners and collapse a sequence of blank characters into one!");
            
            // with the given policy first tokenise by blank space and then tokenise by punctuation character.
            //In the latter, asset the nsp in the second col.
            
            String line = null;
            int lineCount = 0;
            
            while ((line = br.readLine()) != null) {
                lineCount++;
                int tokCount=0;
                if(!line.trim().isEmpty()){
                    for (String tok : line.trim().split(blankDel)) {
                        if (tok.length() != 0) {
                            String[] splitToken = tok.split("((?<="+punctDel+")|(?="+ punctDel+"))");
                            
                            if (splitToken.length != 1) {
                                for (int i = 0; i < splitToken.length - 1; i++) {
                                    pw.println(++tokCount+"\t"+splitToken[i] + "\tnsp");
                                }
                                pw.println(++tokCount+"\t"+splitToken[(splitToken.length - 1)] + "\t");
                            } else {
                                pw.println(++tokCount+"\t"+splitToken[0] + "\t");
                            }
                        } else {
                            System.out.println("Ignored a sequence of blank characters in line " + lineCount);
                        }
                    }
                    pw.println();
                }else{
                    System.out.println("Ignored line " + lineCount +" that contains no alphanumeric char");
                }
            }
            br.close();
            pw.close();
            
            System.out.println("Have a nice day!");
            
        } catch (IOException ex) {
            System.out.println("A problem occured when writing the result! contact admin.");
        }

    }

    public static String loadSeparators(String file) throws FileNotFoundException, IOException {
        String patternSpace = "";
        BufferedReader br = new BufferedReader(new FileReader(file));
        for (String line = br.readLine(); line != null; line = br.readLine()) {
            if (!line.startsWith("#")&&line.trim().length()!=0) {
                //int hexCharCode = Integer.parseInt(line.split("\t")[0].trim(), 16);
                //String delimiter = Character.toString((char) hexCharCode);
                
                patternSpace += "|\\u" + line.split("\t")[0].trim();
            }
        }
        return patternSpace.substring(1);
    }

//    public static void oldMainStanfordTokeniser(String[] args) throws FileNotFoundException, IOException {
//        if (args.length != 2) {
//            System.out.println("Please provide path to input file and the output");
//            System.exit(0);
//        } else if (args[0].equalsIgnoreCase(args[1])) {
//            System.out.println("Input and output path cannot be the same");
//            System.exit(0);
//        }
//
//        BufferedReader br = new BufferedReader(new FileReader(args[0]));
//        PrintWriter pw = new PrintWriter(new FileWriter(args[1]));
//        TokenizerFactory<CoreLabel> tokenizerFactory
//                = PTBTokenizer.factory(new CoreLabelTokenFactory(), "");
//        String line;
//        while ((line = br.readLine()) != null) {
//            List<CoreLabel> tokens
//                    = tokenizerFactory.getTokenizer(
//                            new StringReader(line)).tokenize();
//            tokens.stream().map((token) -> token.toString()).forEach((tokenStr) -> {
//                pw.println(tokenStr);
//            });
//        }
//
//        pw.close();
//        br.close();
//        System.out.println("Have a nice day!");
//
//    }

}
